#include "car.h"
#include "ferry.h"
#include "time.h"

#include <QDebug>

Car::Car(Ferry *ferry) :
	mFerry(ferry)
{
	connect(this, SIGNAL(destroyed(QObject *)), this, SLOT(notify(QObject*)));
	qDebug() << time() << "a wild car" << this << "appears";
}

void Car::run()
{
	qDebug() << time() << "car" << this << "uses load";
	mFerry->loadCar(this);
	qDebug() << time() << "it's super effective. car" << this << "loaded";
	mFerry->unloadCar(this);
	qDebug() << time() << "car" << this << "drove away towards east";
}

QTime Car::time() const
{
	return QTime::currentTime();
}

void Car::notify(QObject *obj)
{
	qDebug() << "object" << (Car *)(obj ? obj : this) << "is being destroyed";
}
