#ifndef FERRY_H
#define FERRY_H

#include <QThread>
#include <QList>
#include <QMutex>
#include <QWaitCondition>
#include <QTime>

class Car;

class Ferry : public QThread
{
	Q_OBJECT
public:
	enum Shore {East, West};

	Ferry(int n = 5, QTime time = QTime(0, 0, 10));
	void loadCar(Car *car);
	Car *unloadCar(Car *car);
	Shore go();
	int capacity();
	void setCapacity(int n);
	QTime waitTime();
	void setWaitTime(QTime time);

private:
	QTime time() const;
	QList<Car *> mCarsAboard;
	Shore mShore;
	QTime mDuration;
	int mCapacity;
	QWaitCondition mLoadWait, mGoWait;
	QMutex mMutex;
	bool mTimedOut;

protected:
	void run();

signals:

public slots:
	void timeout();
};

#endif // FERRY_H
